# frozen_string_literal: true

# @api public
# @since 0.1.0
module LIT
  require "lit/parser"

  require_relative "lit/version"
  require_relative "lit/errors"
  require_relative "lit/object"
  require_relative "lit/builder"
  require_relative "lit/loader"
  require_relative "lit/type_checker"
  require_relative "lit/utils"
  require_relative "lit/module_observer"
  require_relative "lit/serializer"
  require_relative "lit/request_deserializer"

  def self.load(dir)
    Loader.new.load_directory(dir)
  end
end
