# frozen_string_literal: true

module LIT
  module Builder
    # @api private
    # @since 0.1.0
    class Array
      def initialize(mod, type)
        @type_checker = TypeChecker.new(mod)
        @type = type
      end

      def build
        type_checker = @type_checker
        type = @type

        Class.new(::LIT::Object::Array) do
          define_method(:check_type!) do |value|
            type_checker.check_type!(type, value)
          end

          private(:check_type!)
        end
      end
    end
  end
end
