# frozen_string_literal: true

module LIT
  module Object
    # @api public
    # @since 0.1.0
    class Array
      def initialize(*values)
        values.each { |v| check_type!(v) }
        @values = values
      end

      def each(&block)
        @values.each(&block)
      end

      def to_a
        @values
      end

      def [](index)
        @values[index]
      end

      def __values__
        @values
      end

      private

      def check_type!(value); end
    end
  end
end
