# frozen_string_literal: true

module LIT
  module Object
    # @api public
    # @since 0.1.0
    class Map
      attr_reader :values

      def initialize(values = {})
        values = Utils::MapHash.new(values)
        values.each { |k, v| check_type!(k, v) }
        @values = values
      end

      def [](key)
        @values[key]
      end

      def __values__
        @values.to_h
      end

      private

      def check_type!(key, value); end
    end
  end
end
